scala.collection.mutable

# MultiMap

#### trait MultiMap[A, B] extends Map[A, Set[B]]

A trait for mutable maps with multiple values assigned to a key.

This class is typically used as a mixin. It turns maps which map `A` to `Set[B]` objects into multi maps which map `A` to `B` objects.

Source
  MultiMap.scala

Linear Supertypes
Map[A, Set[B]], MapLike[A, Set[B], Map[A, Set[B]]], Cloneable[Map[A, Set[B]]], Shrinkable[A], Builder[(A, Set[B]), Map[A, Set[B]]], Growable[(A, Set[B])], Map[A, Set[B]], MapLike[A, Set[B], Map[A, Set[B]]], Subtractable[A, Map[A, Set[B]]], PartialFunction[A, Set[B]], (A) ⇒ Set[B], GenMap[A, Set[B]], GenMapLike[A, Set[B], Map[A, Set[B]]], Iterable[(A, Set[B])], Iterable[(A, Set[B])], IterableLike[(A, Set[B]), Map[A, Set[B]]], Equals, GenIterable[(A, Set[B])], GenIterableLike[(A, Set[B]), Map[A, Set[B]]], Traversable[(A, Set[B])], Mutable, Traversable[(A, Set[B])], GenTraversable[(A, Set[B])], GenericTraversableTemplate[(A, Set[B]), Iterable], TraversableLike[(A, Set[B]), Map[A, Set[B]]], GenTraversableLike[(A, Set[B]), Map[A, Set[B]]], Parallelizable[(A, Set[B]), ParMap[A, Set[B]]], TraversableOnce[(A, Set[B])], GenTraversableOnce[(A, Set[B])], FilterMonadic[(A, Set[B]), Map[A, Set[B]]], HasNewBuilder[(A, Set[B]), Map[A, Set[B]]], AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. MultiMap
2. Map
3. MapLike
4. Cloneable
5. Shrinkable
6. Builder
7. Growable
8. Map
9. MapLike
10. Subtractable
11. PartialFunction
12. Function1
13. GenMap
14. GenMapLike
15. Iterable
16. Iterable
17. IterableLike
18. Equals
19. GenIterable
20. GenIterableLike
21. Traversable
22. Mutable
23. Traversable
24. GenTraversable
25. GenericTraversableTemplate
26. TraversableLike
27. GenTraversableLike
28. Parallelizable
29. TraversableOnce
30. GenTraversableOnce
31. FilterMonadic
32. HasNewBuilder
33. AnyRef
34. Any

Visibility

1. Public
2. All

### Type Members

1. #### class DefaultKeySet extends Set[A]

   The implementation class of the set returned by `keySet`.

2. #### class DefaultValuesIterable extends Iterable[B]

   The implementation class of the iterable returned by `values`.

3. #### type Self = Map[A, Set[B]]

   The type implementing this traversable

   The type implementing this traversable

   Attributes
     protected
   Definition Classes
     TraversableLike

4. #### class WithFilter extends FilterMonadic[A, Repr]

   A class supporting filtered operations.

### Abstract Value Members

1. #### abstract def +=(kv: (A, Set[B])): MultiMap.this.type

   Adds a new key/value pair to this map.

   Adds a new key/value pair to this map. If the map already contains a mapping for the key, it will be overridden by the new value.

   kv

     the key/value pair.

   returns

     the map itself

   Definition Classes
     MapLike → Builder → Growable

2. #### abstract def -=(key: A): MultiMap.this.type

   Removes a key from this map.

   Removes a key from this map.

   key

     the key to be removed

   returns

     the map itself.

   Definition Classes
     MapLike → Shrinkable

3. #### abstract def get(key: A): Option[Set[B]]

   Optionally returns the value associated with a key.

   Optionally returns the value associated with a key.

   key

     the key value

   returns

     an option value containing the value associated with `key` in this map, or `None` if none exists.

   Definition Classes
     MapLike → GenMapLike

4. #### abstract def iterator: Iterator[(A, Set[B])]

   Creates a new iterator over all key/value pairs of this map

   Creates a new iterator over all key/value pairs of this map

   returns

     the new iterator

   Definition Classes
     MapLike → IterableLike → GenIterableLike

### Concrete Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types.

   Equivalent to `x.hashCode` except for boxed numeric types. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### def +[B1 >: Set[B]](elem1: (A, B1), elem2: (A, B1), elems: (A, B1)*): Map[A, B1]

   Creates a new map containing two or more key/value mappings and all the key/value mappings of this map.

   Creates a new map containing two or more key/value mappings and all the key/value mappings of this map.

   Specified mappings will override existing mappings from this map with the same keys.

   B1

     the type of the added values

   elem1

     the first element to add.

   elem2

     the second element to add.

   elems

     the remaining elements to add.

   returns

     a new map containing mappings of this map and two or more specified mappings.

   Definition Classes
     MapLike → MapLike
   Annotations
     @migration
   Migration

     (Changed in version 2.8.0) `+` creates a new map. Use `+=` to add an element to this map and return that map itself.

5. #### def +[B1 >: Set[B]](kv: (A, B1)): Map[A, B1]

   Creates a new map containing a new key/value mapping and all the key/value mappings of this map.

   Creates a new map containing a new key/value mapping and all the key/value mappings of this map.

   Mapping `kv` will override existing mappings from this map with the same key.

   B1

     the type of the value in the key/value pair.

   kv

     the key/value mapping to be added

   returns

     a new map containing mappings of this map and the mapping `kv`.

   Definition Classes
     MapLike → MapLike → GenMapLike
   Annotations
     @migration
   Migration

     (Changed in version 2.8.0) `+` creates a new map. Use `+=` to add an element to this map and return that map itself.

6. #### def ++[B1 >: Set[B]](xs: GenTraversableOnce[(A, B1)]): Map[A, B1]

   Creates a new map containing the key/value mappings provided by the specified traversable object and all the key/value mappings of this map.

   Creates a new map containing the key/value mappings provided by the specified traversable object and all the key/value mappings of this map.

   Note that existing mappings from this map with the same key as those in `xs` will be overriden.

   B1

     the type of the added values

   xs

     the traversable object.

   returns

     a new map containing mappings of this map and those provided by `xs`.

   Definition Classes
     MapLike → MapLike
   Annotations
     @migration
   Migration

     (Changed in version 2.8.0) `++` creates a new map. Use `++=` to add an element to this map and return that map itself.

7. #### abstract def ++[B](that: GenTraversableOnce[B]): MultiMap[B]

   [use case] Returns a new multimap containing the elements from the left hand operand followed by the elements from the right hand operand.

   [use case]

   Returns a new multimap containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the multimap is the most specific superclass encompassing the element types of the two operands (see example).

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new collection of type `That` which contains all elements of this multimap followed by all elements of `that`.

   Definition Classes
     GenTraversableLike

8. #### def ++[B >: (A, Set[B]), That](that: GenTraversableOnce[B])(implicit bf: CanBuildFrom[Map[A, Set[B]], B, That]): That

   Returns a new multimap containing the elements from the left hand operand followed by the elements from the right hand operand.

   Returns a new multimap containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the multimap is the most specific superclass encompassing the element types of the two operands (see example).

   Example:

           scala> val a = LinkedList(1)
           a: scala.collection.mutable.LinkedList[Int] = LinkedList(1)

           scala> val b = LinkedList(2)
           b: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

           scala> val c = a ++ b
           c: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

           scala> val d = LinkedList('a')
           d: scala.collection.mutable.LinkedList[Char] = LinkedList(a)

           scala> val e = c ++ d
           e: scala.collection.mutable.LinkedList[AnyVal] = LinkedList(1, 2, a)

   B

     the element type of the returned collection.

   That

     the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

   that

     the traversable to append.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

   returns

     a new collection of type `That` which contains all elements of this multimap followed by all elements of `that`.

   Definition Classes
     TraversableLike → GenTraversableLike

9. #### def ++:[B >: (A, Set[B]), That](that: Traversable[B])(implicit bf: CanBuildFrom[Map[A, Set[B]], B, That]): That

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand. It differs from `++` in that the right operand determines the type of the resulting collection rather than the left one.

   Example:

           scala> val x = List(1)
           x: List[Int] = List(1)

           scala> val y = LinkedList(2)
           y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

           scala> val z = x ++: y
           z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

   This overload exists because: for the implementation of `++:` we should reuse that of `++` because many collections override it with more efficient versions.

   Since `TraversableOnce` has no `++` method, we have to implement that directly, but `Traversable` and down can use the overload.

   B

     the element type of the returned collection.

   That

     the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

   that

     the traversable to append.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

   returns

     a new multimap which contains all elements of this multimap followed by all elements of `that`.

   Definition Classes
     TraversableLike

10. #### abstract def ++:[B](that: TraversableOnce[B]): MultiMap[B]

    [use case] Concatenates this multimap with the elements of a traversable collection.

    [use case]

    Concatenates this multimap with the elements of a traversable collection. It differs from ++ in that the right operand determines the type of the resulting collection rather than the left one.

    B

      the element type of the returned collection.

    that

      the traversable to append.

    returns

      a new collection of type `That` which contains all elements of this multimap followed by all elements of `that`.

    Definition Classes
      TraversableLike

11. #### def ++:[B >: (A, Set[B]), That](that: TraversableOnce[B])(implicit bf: CanBuildFrom[Map[A, Set[B]], B, That]): That

    Concatenates this multimap with the elements of a traversable collection.

    Concatenates this multimap with the elements of a traversable collection. It differs from ++ in that the right operand determines the type of the resulting collection rather than the left one.

    Example:

            scala> val x = List(1)
            x: List[Int] = List(1)

            scala> val y = LinkedList(2)
            y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

            scala> val z = x ++: y
            z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

    B

      the element type of the returned collection.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    that

      the traversable to append.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      a new collection of type `That` which contains all elements of this multimap followed by all elements of `that`.

    Definition Classes
      TraversableLike

12. #### def ++=(xs: TraversableOnce[(A, Set[B])]): MultiMap.this.type

    adds all elements produced by a TraversableOnce to this multimap.

    adds all elements produced by a TraversableOnce to this multimap.

    returns

      the multimap itself.

    Definition Classes
      Growable

13. #### def +=(elem1: (A, Set[B]), elem2: (A, Set[B]), elems: (A, Set[B])*): MultiMap.this.type

    adds two or more elements to this multimap.

    adds two or more elements to this multimap.

    elem1

      the first element to add.

    elem2

      the second element to add.

    elems

      the remaining elements to add.

    returns

      the multimap itself

    Definition Classes
      Growable

14. #### def -(elem1: A, elem2: A, elems: A*): Map[A, Set[B]]

    Creates a new map with all the key/value mappings of this map except mappings with keys equal to any of the two or more specified keys.

    Creates a new map with all the key/value mappings of this map except mappings with keys equal to any of the two or more specified keys.

    elem1

      the first element to remove.

    elem2

      the second element to remove.

    elems

      the remaining elements to remove.

    returns

      a new map containing all the mappings of this map except mappings with a key equal to `elem1`, `elem2` or any of `elems`.

    Definition Classes
      MapLike → Subtractable
    Annotations
      @migration
    Migration

      (Changed in version 2.8.0) `-` creates a new map. Use `-=` to remove an element from this map and return that map itself.

15. #### def -(key: A): Map[A, Set[B]]

    Creates a new map with all the key/value mappings of this map except the key/value mapping with the specified key.

    Creates a new map with all the key/value mappings of this map except the key/value mapping with the specified key.

    key

      the key to be removed

    returns

      a new map with all the mappings of this map except that with a key `key`.

    Definition Classes
      MapLike → MapLike → Subtractable → GenMapLike
    Annotations
      @migration
    Migration

      (Changed in version 2.8.0) `-` creates a new map. Use `-=` to remove an element from this map and return that map itself.

16. #### def --(xs: GenTraversableOnce[A]): Map[A, Set[B]]

    Creates a new map with all the key/value mappings of this map except mappings with keys equal to any of those provided by the specified traversable object.

    Creates a new map with all the key/value mappings of this map except mappings with keys equal to any of those provided by the specified traversable object.

    xs

      the traversable object.

    returns

      a new map with all the key/value mappings of this map except mappings with a key equal to a key from `xs`.

    Definition Classes
      MapLike → Subtractable
    Annotations
      @migration
    Migration

      (Changed in version 2.8.0) `--` creates a new map. Use `--=` to remove an element from this map and return that map itself.

17. #### def --=(xs: TraversableOnce[A]): MultiMap.this.type

    Removes all elements produced by an iterator from this multimap.

    Removes all elements produced by an iterator from this multimap.

    returns

      the multimap itself

    Definition Classes
      Shrinkable

18. #### def -=(elem1: A, elem2: A, elems: A*): MultiMap.this.type

    Removes two or more elements from this multimap.

    Removes two or more elements from this multimap.

    elem1

      the first element to remove.

    elem2

      the second element to remove.

    elems

      the remaining elements to remove.

    returns

      the multimap itself

    Definition Classes
      Shrinkable

19. #### def /:[B](z: B)(op: (B, (A, Set[B])) ⇒ B): B

    Applies a binary operator to a start value and all elements of this multimap, going left to right.

    Applies a binary operator to a start value and all elements of this multimap, going left to right.

    Note: `/:` is alternate syntax for `foldLeft`; `z /: xs` is the same as `xs foldLeft z`.

    Examples:

    Note that the folding function used to compute b is equivalent to that used to compute c.

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = (5 /: a)(_+_)
             b: Int = 15

             scala> val c = (5 /: a)((x,y) => x + y)
             c: Int = 15

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this multimap, going left to right with the start value `z` on the left:

                      op(...op(op(z, x1), x2), ..., xn)

      where `x1, ..., xn` are the elements of this multimap.

    Definition Classes
      TraversableOnce → GenTraversableOnce

20. #### def /:\[A1 >: (A, Set[B])](z: A1)(op: (A1, A1) ⇒ A1): A1

    A syntactic sugar for out of order folding.

    A syntactic sugar for out of order folding. See `fold`.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = (a /:\ 5)(_+_)
             b: Int = 15

    Definition Classes
      GenTraversableOnce

21. #### def :\[B](z: B)(op: ((A, Set[B]), B) ⇒ B): B

    Applies a binary operator to all elements of this multimap and a start value, going right to left.

    Applies a binary operator to all elements of this multimap and a start value, going right to left.

    Note: `:\` is alternate syntax for `foldRight`; `xs :\ z` is the same as `xs foldRight z`.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    Examples:

    Note that the folding function used to compute b is equivalent to that used to compute c.

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = (a :\ 5)(_+_)
             b: Int = 15

             scala> val c = (a :\ 5)((x,y) => x + y)
             c: Int = 15

    B

      the result type of the binary operator.

    z

      the start value

    op

      the binary operator

    returns

      the result of inserting `op` between consecutive elements of this multimap, going right to left with the start value `z` on the right:

                      op(x1, op(x2, ... op(xn, z)...))

      where `x1, ..., xn` are the elements of this multimap.

    Definition Classes
      TraversableOnce → GenTraversableOnce

22. #### final def ==(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

23. #### final def ==(arg0: Any): Boolean

    Test two objects for equality.

    Test two objects for equality.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      Any

24. #### def addBinding(key: A, value: B): MultiMap.this.type

    Assigns the specified `value` to a specified `key`, replacing the existing value assigned to that `key` if it is equal to the specified value.

    Assigns the specified `value` to a specified `key`, replacing the existing value assigned to that `key` if it is equal to the specified value. Otherwise, simply adds another binding to the `key`.

    key

      The key to which to bind the new value.

    value

      The value to bind to the key.

    returns

      A reference to this multimap.

25. #### def addString(b: StringBuilder, start: String, sep: String, end: String): StringBuilder

    Appends all bindings of this map to a string builder using start, end, and separator strings.

    Appends all bindings of this map to a string builder using start, end, and separator strings. The written text begins with the string `start` and ends with the string `end`. Inside, the string representations of all bindings of this map in the form of `key -> value` are separated by the string `sep`.

    b

      the builder to which strings are appended.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      MapLike → TraversableOnce

26. #### def addString(b: StringBuilder): StringBuilder

    Appends all elements of this multimap to a string builder.

    Appends all elements of this multimap to a string builder. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this multimap without any separator string.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = new StringBuilder()
             b: StringBuilder =

             scala> val h = a.addString(b)
             b: StringBuilder = 1234

    b

      the string builder to which elements are appended.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

27. #### def addString(b: StringBuilder, sep: String): StringBuilder

    Appends all elements of this multimap to a string builder using a separator string.

    Appends all elements of this multimap to a string builder using a separator string. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this multimap, separated by the string `sep`.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = new StringBuilder()
             b: StringBuilder =

             scala> a.addString(b, ", ")
             res0: StringBuilder = 1, 2, 3, 4

    b

      the string builder to which elements are appended.

    sep

      the separator string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

28. #### def aggregate[B](z: B)(seqop: (B, (A, Set[B])) ⇒ B, combop: (B, B) ⇒ B): B

    Aggregates the results of applying an operator to subsequent elements.

    Aggregates the results of applying an operator to subsequent elements.

    This is a more general form of `fold` and `reduce`. It has similar semantics, but does not require the result to be a supertype of the element type. It traverses the elements in different partitions sequentially, using `seqop` to update the result, and then applies `combop` to results from different partitions. The implementation of this operation may operate on an arbitrary number of collection partitions, so `combop` may be invoked an arbitrary number of times.

    For example, one might want to process some elements and then produce a `Set`. In this case, `seqop` would process an element and append it to the list, while `combop` would concatenate two lists from different partitions together. The initial value `z` would be an empty set.

           pc.aggregate(Set[Int]())(_ += process(_), _ ++ _)

    Another example is calculating geometric mean from a collection of doubles (one would typically require big doubles for this).

    B

      the type of accumulated results

    z

      the initial value for the accumulated result of the partition - this will typically be the neutral element for the `seqop` operator (e.g. `Nil` for list concatenation or `0` for summation)

    seqop

      an operator used to accumulate results within a partition

    combop

      an associative operator used to combine results from different partitions

    Definition Classes
      TraversableOnce → GenTraversableOnce

29. #### def andThen[C](k: (Set[B]) ⇒ C): PartialFunction[A, C]

    Composes this partial function with a transformation function that gets applied to results of this partial function.

    Composes this partial function with a transformation function that gets applied to results of this partial function.

    C

      the result type of the transformation function.

    k

      the transformation function

    returns

      a partial function with the same domain as this partial function, which maps arguments `x` to `k(this(x))`.

    Definition Classes
      PartialFunction → Function1

30. #### def apply(key: A): Set[B]

    Retrieves the value which is associated with the given key.

    Retrieves the value which is associated with the given key. This method invokes the `default` method of the map if there is no mapping from the given key to a value. Unless overridden, the `default` method throws a `NoSuchElementException`.

    key

      the key

    returns

      the value associated with the given key, or the result of the map's `default` method, if none exists.

    Definition Classes
      MapLike → GenMapLike → Function1

31. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

32. #### def canEqual(that: Any): Boolean

    Method called from equality methods, so that user-defined subclasses can refuse to be equal to other collections of the same kind.

    Method called from equality methods, so that user-defined subclasses can refuse to be equal to other collections of the same kind.

    that

      The object with which this multimap should be compared

    returns

      `true`, if this multimap can possibly equal `that`, `false` otherwise. The test takes into consideration only the run-time types of objects but ignores their elements.

    Definition Classes
      IterableLike → Equals

33. #### def clear(): Unit

    Removes all bindings from the map.

    Removes all bindings from the map. After this operation has completed, the map will be empty.

    Definition Classes
      MapLike → Builder → Growable

34. #### def clone(): Map[A, Set[B]]

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Definition Classes
      MapLike → Cloneable → AnyRef
    Note

      not specified by SLS as a member of AnyRef

35. #### abstract def collect[B](pf: PartialFunction[(A, Set[B]), B]): MultiMap[B]

    [use case] Builds a new collection by applying a partial function to all elements of this multimap on which the function is defined.

    [use case]

    Builds a new collection by applying a partial function to all elements of this multimap on which the function is defined.

    B

      the element type of the returned collection.

    pf

      the partial function which filters and maps the multimap.

    returns

      a new collection of type `That` resulting from applying the partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      GenTraversableLike

36. #### def collect[B, That](pf: PartialFunction[(A, Set[B]), B])(implicit bf: CanBuildFrom[Map[A, Set[B]], B, That]): That

    Builds a new collection by applying a partial function to all elements of this multimap on which the function is defined.

    Builds a new collection by applying a partial function to all elements of this multimap on which the function is defined.

    B

      the element type of the returned collection.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    pf

      the partial function which filters and maps the multimap.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      a new collection of type `That` resulting from applying the partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

37. #### def collectFirst[B](pf: PartialFunction[(A, Set[B]), B]): Option[B]

    Finds the first element of the multimap for which the given partial function is defined, and applies the partial function to it.

    Finds the first element of the multimap for which the given partial function is defined, and applies the partial function to it.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    pf

      the partial function

    returns

      an option value containing pf applied to the first value for which it is defined, or `None` if none exists.

    Definition Classes
      TraversableOnce
    Example:

    1. `Seq("a", 1, 5L).collectFirst({ case x: Int => x*10 }) = Some(10)`

38. #### def companion: GenericCompanion[Iterable]

    The factory companion object that builds instances of class MultiMap.

    The factory companion object that builds instances of class MultiMap. (or its `Iterable` superclass where class MultiMap is not a `Seq`.)

    Definition Classes
      Iterable → Iterable → GenIterable → Traversable → Traversable → GenTraversable → GenericTraversableTemplate

39. #### def compose[A](g: (A) ⇒ A): (A) ⇒ Set[B]

    Composes two instances of Function1 in a new Function1, with this function applied last.

    Composes two instances of Function1 in a new Function1, with this function applied last.

    A

      the type to which function `g` can be applied

    g

      a function A => T1

    returns

      a new function `f` such that `f(x) == apply(g(x))`

    Definition Classes
      Function1

40. #### def contains(key: A): Boolean

    Tests whether this map contains a binding for a key.

    Tests whether this map contains a binding for a key.

    key

      the key

    returns

      `true` if there is a binding for `key` in this map, `false` otherwise.

    Definition Classes
      MapLike

41. #### abstract def copyToArray(xs: Array[(A, Set[B])], start: Int, len: Int): Unit

    [use case] Copies elements of this multimap to an array.

    [use case]

    Copies elements of this multimap to an array. Fills the given array `xs` with at most `len` elements of this multimap, starting at position `start`. Copying will stop once either the end of the current multimap is reached, or the end of the array is reached, or `len` elements have been copied.

    xs

      the array to fill.

    start

      the starting index.

    len

      the maximal number of elements to copy.

    Definition Classes
      TraversableLike

42. #### def copyToArray[B >: (A, Set[B])](xs: Array[B], start: Int, len: Int): Unit

    Copies elements of this multimap to an array.

    Copies elements of this multimap to an array. Fills the given array `xs` with at most `len` elements of this multimap, starting at position `start`. Copying will stop once either the end of the current multimap is reached, or the end of the array is reached, or `len` elements have been copied.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    start

      the starting index.

    len

      the maximal number of elements to copy.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

43. #### abstract def copyToArray(xs: Array[(A, Set[B])]): Unit

    [use case] Copies values of this multimap to an array.

    [use case]

    Copies values of this multimap to an array. Fills the given array `xs` with values of this multimap. Copying will stop once either the end of the current multimap is reached, or the end of the array is reached.

    xs

      the array to fill.

    Definition Classes
      GenTraversableOnce

44. #### def copyToArray[B >: (A, Set[B])](xs: Array[B]): Unit

    Copies values of this multimap to an array.

    Copies values of this multimap to an array. Fills the given array `xs` with values of this multimap. Copying will stop once either the end of the current multimap is reached, or the end of the array is reached.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    Definition Classes
      TraversableOnce → GenTraversableOnce

45. #### abstract def copyToArray(xs: Array[(A, Set[B])], start: Int): Unit

    [use case] Copies values of this multimap to an array.

    [use case]

    Copies values of this multimap to an array. Fills the given array `xs` with values of this multimap, beginning at index `start`. Copying will stop once either the end of the current multimap is reached, or the end of the array is reached.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      GenTraversableOnce

46. #### def copyToArray[B >: (A, Set[B])](xs: Array[B], start: Int): Unit

    Copies values of this multimap to an array.

    Copies values of this multimap to an array. Fills the given array `xs` with values of this multimap, beginning at index `start`. Copying will stop once either the end of the current multimap is reached, or the end of the array is reached.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      TraversableOnce → GenTraversableOnce

47. #### def copyToBuffer[B >: (A, Set[B])](dest: Buffer[B]): Unit

    Copies all elements of this multimap to a buffer.

    Copies all elements of this multimap to a buffer.

    dest

      The buffer to which elements are copied.

    Definition Classes
      TraversableOnce

48. #### def count(p: ((A, Set[B])) ⇒ Boolean): Int

    Counts the number of elements in the multimap which satisfy a predicate.

    Counts the number of elements in the multimap which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      the number of elements satisfying the predicate `p`.

    Definition Classes
      TraversableOnce → GenTraversableOnce

49. #### def default(key: A): Set[B]

    Defines the default value computation for the map, returned when a key is not found The method implemented here throws an exception, but it might be overridden in subclasses.

    Defines the default value computation for the map, returned when a key is not found The method implemented here throws an exception, but it might be overridden in subclasses.

    key

      the given key value for which a binding is missing.

    Definition Classes
      MapLike → GenMapLike
    Exceptions thrown
      `NoSuchElementException`

50. #### def drop(n: Int): Map[A, Set[B]]

    Selects all elements except first n ones.

    Selects all elements except first n ones.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    n

      the number of elements to drop from this multimap.

    returns

      a multimap consisting of all elements of this multimap except the first `n` ones, or else the empty multimap, if this multimap has less than `n` elements.

    Definition Classes
      IterableLike → TraversableLike → GenTraversableLike

51. #### def dropRight(n: Int): Map[A, Set[B]]

    Selects all elements except last n ones.

    Selects all elements except last n ones.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    n

      The number of elements to take

    returns

      a multimap consisting of all elements of this multimap except the last `n` ones, or else the empty multimap, if this multimap has less than `n` elements.

    Definition Classes
      IterableLike

52. #### def dropWhile(p: ((A, Set[B])) ⇒ Boolean): Map[A, Set[B]]

    Drops longest prefix of elements that satisfy a predicate.

    Drops longest prefix of elements that satisfy a predicate.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    p

      The predicate used to test elements.

    returns

      the longest suffix of this multimap whose first element does not satisfy the predicate `p`.

    Definition Classes
      TraversableLike → GenTraversableLike

53. #### def empty: Map[A, Set[B]]

    The empty map of the same type as this map

    The empty map of the same type as this map

    returns

      an empty map of type `This`.

    Definition Classes
      Map → Map → MapLike

54. #### def entryExists(key: A, p: (B) ⇒ Boolean): Boolean

    Checks if there exists a binding to `key` such that it satisfies the predicate `p`.

    Checks if there exists a binding to `key` such that it satisfies the predicate `p`.

    key

      The key for which the predicate is checked.

    p

      The predicate which a value assigned to the key must satisfy.

    returns

      A boolean if such a binding exists

55. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

56. #### def equals(that: Any): Boolean

    Compares two maps structurally; i.

    Compares two maps structurally; i.e. checks if all mappings contained in this map are also contained in the other map, and vice versa.

    that

      the other map

    returns

      `true` if both maps contain exactly the same mappings, `false` otherwise.

    Definition Classes
      GenMapLike → Equals → AnyRef → Any

57. #### def exists(p: ((A, Set[B])) ⇒ Boolean): Boolean

    Tests whether a predicate holds for some of the elements of this multimap.

    Tests whether a predicate holds for some of the elements of this multimap.

    p

      the predicate used to test elements.

    returns

      `true` if the given predicate `p` holds for some of the elements of this multimap, otherwise `false`.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

58. #### def filter(p: ((A, Set[B])) ⇒ Boolean): Map[A, Set[B]]

    Selects all elements of this multimap which satisfy a predicate.

    Selects all elements of this multimap which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      a new multimap consisting of all elements of this multimap that satisfy the given predicate `p`. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

59. #### def filterKeys(p: (A) ⇒ Boolean): Map[A, Set[B]]

    Filters this map by retaining only keys satisfying a predicate.

    Filters this map by retaining only keys satisfying a predicate.

    p

      the predicate used to test keys

    returns

      an immutable map consisting only of those key value pairs of this map where the key satisfies the predicate `p`. The resulting map wraps the original map without copying any elements.

    Definition Classes
      MapLike

60. #### def filterNot(p: ((A, Set[B])) ⇒ Boolean): Map[A, Set[B]]

    Returns a new map with all key/value pairs for which the predicate `p` returns `true`.

    Returns a new map with all key/value pairs for which the predicate `p` returns `true`.

    Note: This method works by successively removing elements fro which the predicate is false from this set. If removal is slow, or you expect that most elements of the set will be removed, you might consider using `filter` with a negated predicate instead.

    p

      A predicate over key-value pairs

    returns

      A new map containing elements not satisfying the predicate.

    Definition Classes
      MapLike → TraversableLike → GenTraversableLike

61. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

62. #### def find(p: ((A, Set[B])) ⇒ Boolean): Option[(A, Set[B])]

    Finds the first element of the multimap satisfying a predicate, if any.

    Finds the first element of the multimap satisfying a predicate, if any.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    p

      the predicate used to test elements.

    returns

      an option value containing the first element in the multimap that satisfies `p`, or `None` if none exists.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

63. #### abstract def flatMap[B](f: ((A, Set[B])) ⇒ GenTraversableOnce[B]): MultiMap[B]

    [use case] Builds a new collection by applying a function to all elements of this multimap and using the elements of the resulting collections.

    [use case]

    Builds a new collection by applying a function to all elements of this multimap and using the elements of the resulting collections. For example:

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new collection of type `That` resulting from applying the given collection-valued function `f` to each element of this multimap and concatenating the results.

    Definition Classes
      GenTraversableLike

64. #### def flatMap[B, That](f: ((A, Set[B])) ⇒ GenTraversableOnce[B])(implicit bf: CanBuildFrom[Map[A, Set[B]], B, That]): That

    Builds a new collection by applying a function to all elements of this multimap and using the elements of the resulting collections.

    Builds a new collection by applying a function to all elements of this multimap and using the elements of the resulting collections. For example:

         def getWords(lines: Seq[String]): Seq[String] = lines flatMap (line => line split "\\W+")

    The type of the resulting collection is guided by the static type of multimap. This might cause unexpected results sometimes. For example:

         // lettersOf will return a Seq[Char] of likely repeated letters, instead of a Set
         def lettersOf(words: Seq[String]) = words flatMap (word => word.toSet)

         // lettersOf will return a Set[Char], not a Seq
         def lettersOf(words: Seq[String]) = words.toSet flatMap (word => word.toSeq)

         // xs will be a an Iterable[Int]
         val xs = Map("a" -> List(11,111), "b" -> List(22,222)).flatMap(_._2)

         // ys will be a Map[Int, Int]
         val ys = Map("a" -> List(1 -> 11,1 -> 111), "b" -> List(2 -> 22,2 -> 222)).flatMap(_._2)

    B

      the element type of the returned collection.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    f

      the function to apply to each element.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      a new collection of type `That` resulting from applying the given collection-valued function `f` to each element of this multimap and concatenating the results.

    Definition Classes
      TraversableLike → GenTraversableLike → FilterMonadic

65. #### abstract def flatten[B]: MultiMap[B]

    [use case] Converts this multimap of traversable collections into a multimap formed by the elements of these traversable collections.

    [use case]

    Converts this multimap of traversable collections into a multimap formed by the elements of these traversable collections.

    B

      the type of the elements of each traversable collection.

    returns

      a new multimap resulting from concatenating all element multimaps.

    Definition Classes
      GenericTraversableTemplate

66. #### def fold[A1 >: (A, Set[B])](z: A1)(op: (A1, A1) ⇒ A1): A1

    Folds the elements of this multimap using the specified associative binary operator.

    Folds the elements of this multimap using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      a type parameter for the binary operator, a supertype of `A`.

    z

      a neutral element for the fold operation; may be added to the result an arbitrary number of times, and must not change the result (e.g., `Nil` for list concatenation, 0 for addition, or 1 for multiplication.)

    op

      a binary operator that must be associative

    returns

      the result of applying fold operator `op` between all the elements and `z`

    Definition Classes
      TraversableOnce → GenTraversableOnce

67. #### def foldLeft[B](z: B)(op: (B, (A, Set[B])) ⇒ B): B

    Applies a binary operator to a start value and all elements of this multimap, going left to right.

    Applies a binary operator to a start value and all elements of this multimap, going left to right.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this multimap, going left to right with the start value `z` on the left:

                      op(...op(z, x1), x2, ..., xn)

      where `x1, ..., xn` are the elements of this multimap.

    Definition Classes
      TraversableOnce → GenTraversableOnce

68. #### def foldRight[B](z: B)(op: ((A, Set[B]), B) ⇒ B): B

    Applies a binary operator to all elements of this multimap and a start value, going right to left.

    Applies a binary operator to all elements of this multimap and a start value, going right to left.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this multimap, going right to left with the start value `z` on the right:

                      op(x1, op(x2, ... op(xn, z)...))

      where `x1, ..., xn` are the elements of this multimap.

    Definition Classes
      IterableLike → TraversableOnce → GenTraversableOnce

69. #### def forall(p: ((A, Set[B])) ⇒ Boolean): Boolean

    Tests whether a predicate holds for all elements of this multimap.

    Tests whether a predicate holds for all elements of this multimap.

    p

      the predicate used to test elements.

    returns

      `true` if the given predicate `p` holds for all elements of this multimap, otherwise `false`.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

70. #### abstract def foreach(f: ((A, Set[B])) ⇒ Unit): Unit

    [use case] Applies a function `f` to all elements of this multimap.

    [use case]

    Applies a function `f` to all elements of this multimap.

    f

      the function that is applied for its side-effect to every element. The result of function `f` is discarded.

    Definition Classes
      IterableLike

71. #### def foreach[U](f: ((A, Set[B])) ⇒ U): Unit

    Applies a function `f` to all elements of this multimap.

    Applies a function `f` to all elements of this multimap.

    Note: this method underlies the implementation of most other bulk operations. Subclasses should re-implement this method if a more efficient implementation exists.

    U

      the type parameter describing the result of function `f`. This result will always be ignored. Typically `U` is `Unit`, but this is not necessary.

    f

      the function that is applied for its side-effect to every element. The result of function `f` is discarded.

    Definition Classes
      IterableLike → TraversableLike → GenTraversableLike → TraversableOnce → GenTraversableOnce → FilterMonadic

72. #### def genericBuilder[B]: Builder[B, Iterable[B]]

    The generic builder that builds instances of MultiMap at arbitrary element types.

    The generic builder that builds instances of MultiMap at arbitrary element types.

    Definition Classes
      GenericTraversableTemplate

73. #### final def getClass(): java.lang.Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

74. #### abstract def getOrElse(key: A, default: ⇒ Set[B]): Set[B]

    [use case] Returns the value associated with a key, or a default value if the key is not contained in the map.

    [use case]

    Returns the value associated with a key, or a default value if the key is not contained in the map.

    key

      the key.

    default

      a computation that yields a default value in case no binding for `key` is found in the map.

    returns

      the value associated with `key` if it exists, otherwise the result of the `default` computation.

    Definition Classes
      MapLike

75. #### def getOrElse[B1 >: Set[B]](key: A, default: ⇒ B1): B1

    Returns the value associated with a key, or a default value if the key is not contained in the map.

    Returns the value associated with a key, or a default value if the key is not contained in the map.

    B1

      the result type of the default computation.

    key

      the key.

    default

      a computation that yields a default value in case no binding for `key` is found in the map.

    returns

      the value associated with `key` if it exists, otherwise the result of the `default` computation.

    Definition Classes
      MapLike

76. #### def getOrElseUpdate(key: A, op: ⇒ Set[B]): Set[B]

    If given key is already in this map, returns associated value.

    If given key is already in this map, returns associated value.

    Otherwise, computes value from given expression `op`, stores with key in map and returns that value.

    key

      the key to test

    op

      the computation yielding the value to associate with `key`, if `key` is previously unbound.

    returns

      the value associated with key (either previously or as a result of executing the method).

    Definition Classes
      MapLike

77. #### def groupBy[K](f: ((A, Set[B])) ⇒ K): Map[K, Map[A, Set[B]]]

    Partitions this multimap into a map of multimaps according to some discriminator function.

    Partitions this multimap into a map of multimaps according to some discriminator function.

    Note: this method is not re-implemented by views. This means when applied to a view it will always force the view and return a new multimap.

    K

      the type of keys returned by the discriminator function.

    f

      the discriminator function.

    returns

      A map from keys to multimaps such that the following invariant holds:

                          (xs partition f)(k) = xs filter (x => f(x) == k)

      That is, every key `k` is bound to a multimap of those elements `x` for which `f(x)` equals `k`.

    Definition Classes
      TraversableLike → GenTraversableLike

78. #### def grouped(size: Int): Iterator[Map[A, Set[B]]]

    Partitions elements in fixed size multimaps.

    Partitions elements in fixed size multimaps.

    size

      the number of elements per group

    returns

      An iterator producing multimaps of size `size`, except the last will be truncated if the elements don't divide evenly.

    Definition Classes
      IterableLike
    See also

      Iterator#grouped

79. #### def hasDefiniteSize: Boolean

    Tests whether this multimap is known to have a finite size.

    Tests whether this multimap is known to have a finite size. All strict collections are known to have finite size. For a non-strict collection such as `Stream`, the predicate returns `true` if all elements have been computed. It returns `false` if the stream is not yet evaluated to the end.

    Note: many collection methods will not work on collections of infinite sizes.

    returns

      `true` if this collection is known to have finite size, `false` otherwise.

    Definition Classes
      TraversableLike → TraversableOnce → GenTraversableOnce

80. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in Any.

    returns

      the hash code value for this object.

    Definition Classes
      GenMapLike → AnyRef → Any

81. #### def head: (A, Set[B])

    Selects the first element of this multimap.

    Selects the first element of this multimap.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the first element of this multimap.

    Definition Classes
      IterableLike → GenIterableLike → TraversableLike → GenTraversableLike
    Exceptions thrown
      `NoSuchElementException`

      if the multimap is empty.

82. #### def headOption: Option[(A, Set[B])]

    Optionally selects the first element.

    Optionally selects the first element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the first element of this multimap if it is nonempty, `None` if it is empty.

    Definition Classes
      TraversableLike

83. #### def init: Map[A, Set[B]]

    Selects all elements except the last.

    Selects all elements except the last.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      a multimap consisting of all elements of this multimap except the last one.

    Definition Classes
      TraversableLike
    Exceptions thrown
      `UnsupportedOperationException`

      if the multimap is empty.

84. #### def inits: Iterator[Map[A, Set[B]]]

    Iterates over the inits of this multimap.

    Iterates over the inits of this multimap. The first value will be this multimap and the final one will be an empty multimap, with the intervening values the results of successive applications of `init`.

    returns

      an iterator over all the inits of this multimap

    Definition Classes
      TraversableLike
    Example:

    1. `List(1,2,3).inits = Iterator(List(1,2,3), List(1,2), List(1), Nil)`

85. #### def isDefinedAt(key: A): Boolean

    Tests whether this map contains a binding for a key.

    Tests whether this map contains a binding for a key. This method, which implements an abstract method of trait `PartialFunction`, is equivalent to `contains`.

    key

      the key

    returns

      `true` if there is a binding for `key` in this map, `false` otherwise.

    Definition Classes
      MapLike → PartialFunction

86. #### def isEmpty: Boolean

    Tests whether the map is empty.

    Tests whether the map is empty.

    returns

      `true` if the map does not contain any key/value binding, `false` otherwise.

    Definition Classes
      MapLike → IterableLike → GenIterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

87. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

88. #### final def isTraversableAgain: Boolean

    Tests whether this multimap can be repeatedly traversed.

    Tests whether this multimap can be repeatedly traversed.

    returns

      `true`

    Definition Classes
      GenTraversableLike → GenTraversableOnce

89. #### def keySet: Set[A]

    Collects all keys of this map in a set.

    Collects all keys of this map in a set.

    returns

      a set containing all keys of this map.

    Definition Classes
      MapLike

90. #### def keys: Iterable[A]

    Collects all keys of this map in an iterable collection.

    Collects all keys of this map in an iterable collection.

    returns

      the keys of this map as an iterable.

    Definition Classes
      MapLike
    Annotations
      @migration
    Migration

      (Changed in version 2.8.0) `keys` returns `Iterable[A]` rather than `Iterator[A]`.

91. #### def keysIterator: Iterator[A]

    Creates an iterator for all keys.

    Creates an iterator for all keys.

    returns

      an iterator over all keys.

    Definition Classes
      MapLike

92. #### def last: (A, Set[B])

    Selects the last element.

    Selects the last element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      The last element of this multimap.

    Definition Classes
      TraversableLike
    Exceptions thrown
      NoSuchElementException

      If the multimap is empty.

93. #### def lastOption: Option[(A, Set[B])]

    Optionally selects the last element.

    Optionally selects the last element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the last element of this multimap$ if it is nonempty, `None` if it is empty.

    Definition Classes
      TraversableLike

94. #### def lift: (A) ⇒ Option[Set[B]]

    Turns this partial function into an plain function returning an `Option` result.

    Turns this partial function into an plain function returning an `Option` result.

    returns

      a function that takes an argument `x` to `Some(this(x))` if `this` is defined for `x`, and to `None` otherwise.

    Definition Classes
      PartialFunction
    See also

      Function.unlift

95. #### def makeSet: Set[B]

    Creates a new set.

    Creates a new set.

    Classes that use this trait as a mixin can override this method to have the desired implementation of sets assigned to new keys. By default this is `HashSet`.

    returns

      An empty set of values of type `B`.

    Attributes
      protected

96. #### abstract def map[B](f: ((A, Set[B])) ⇒ B): MultiMap[B]

    [use case] Builds a new collection by applying a function to all elements of this multimap.

    [use case]

    Builds a new collection by applying a function to all elements of this multimap.

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new collection of type `That` resulting from applying the given function `f` to each element of this multimap and collecting the results.

    Definition Classes
      GenTraversableLike

97. #### def map[B, That](f: ((A, Set[B])) ⇒ B)(implicit bf: CanBuildFrom[Map[A, Set[B]], B, That]): That

    Builds a new collection by applying a function to all elements of this multimap.

    Builds a new collection by applying a function to all elements of this multimap.

    B

      the element type of the returned collection.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    f

      the function to apply to each element.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      a new collection of type `That` resulting from applying the given function `f` to each element of this multimap and collecting the results.

    Definition Classes
      TraversableLike → GenTraversableLike → FilterMonadic

98. #### def mapResult[NewTo](f: (Map[A, Set[B]]) ⇒ NewTo): Builder[(A, Set[B]), NewTo]

    Creates a new builder by applying a transformation function to the results of this builder.

    Creates a new builder by applying a transformation function to the results of this builder.

    NewTo

      the type of collection returned by `f`.

    f

      the transformation function.

    returns

      a new builder which is the same as the current builder except that a transformation function is applied to this builder's result.

    Definition Classes
      Builder

99. #### def mapValues[C](f: (Set[B]) ⇒ C): Map[A, C]

    Transforms this map by applying a function to every retrieved value.

    Transforms this map by applying a function to every retrieved value.

    f

      the function used to transform values of this map.

    returns

      a map view which maps every key of this map to `f(this(key))`. The resulting map wraps the original map without copying any elements.

    Definition Classes
      MapLike

100. #### abstract def max: (A, Set[B])

     [use case] Finds the largest element.

     [use case]

     Finds the largest element.

     returns

       the largest element of this multimap with respect to the ordering `cmp`.

     Definition Classes
       GenTraversableOnce

101. #### def max[B >: (A, Set[B])](implicit cmp: Ordering[B]): (A, Set[B])

     Finds the largest element.

     Finds the largest element.

     B

       The type over which the ordering is defined.

     cmp

       An ordering to be used for comparing elements.

     returns

       the largest element of this multimap with respect to the ordering `cmp`.

     Definition Classes
       TraversableOnce → GenTraversableOnce

102. #### def maxBy[B](f: ((A, Set[B])) ⇒ B)(implicit cmp: Ordering[B]): (A, Set[B])

     Definition Classes
       TraversableOnce → GenTraversableOnce

103. #### abstract def min: (A, Set[B])

     [use case] Finds the smallest element.

     [use case]

     Finds the smallest element.

     returns

       the smallest element of this multimap with respect to the ordering `cmp`.

     Definition Classes
       GenTraversableOnce

104. #### def min[B >: (A, Set[B])](implicit cmp: Ordering[B]): (A, Set[B])

     Finds the smallest element.

     Finds the smallest element.

     B

       The type over which the ordering is defined.

     cmp

       An ordering to be used for comparing elements.

     returns

       the smallest element of this multimap with respect to the ordering `cmp`.

     Definition Classes
       TraversableOnce → GenTraversableOnce

105. #### def minBy[B](f: ((A, Set[B])) ⇒ B)(implicit cmp: Ordering[B]): (A, Set[B])

     Definition Classes
       TraversableOnce → GenTraversableOnce

106. #### def mkString: String

     Displays all elements of this multimap in a string.

     Displays all elements of this multimap in a string.

     returns

       a string representation of this multimap. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this multimap follow each other without any separator string.

     Definition Classes
       TraversableOnce → GenTraversableOnce

107. #### def mkString(sep: String): String

     Displays all elements of this multimap in a string using a separator string.

     Displays all elements of this multimap in a string using a separator string.

     sep

       the separator string.

     returns

       a string representation of this multimap. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this multimap are separated by the string `sep`.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Example:

     1. `List(1, 2, 3).mkString("|") = "1|2|3"`

108. #### def mkString(start: String, sep: String, end: String): String

     Displays all elements of this multimap in a string using start, end, and separator strings.

     Displays all elements of this multimap in a string using start, end, and separator strings.

     start

       the starting string.

     sep

       the separator string.

     end

       the ending string.

     returns

       a string representation of this multimap. The resulting string begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this multimap are separated by the string `sep`.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Example:

     1. `List(1, 2, 3).mkString("(", "; ", ")") = "(1; 2; 3)"`

109. #### final def ne(arg0: AnyRef): Boolean

     Equivalent to `!(this eq that)`.

     Equivalent to `!(this eq that)`.

     returns

       `true` if the argument is not a reference to the receiver object; `false` otherwise.

     Definition Classes
       AnyRef

110. #### def newBuilder: Builder[(A, Set[B]), Map[A, Set[B]]]

     A common implementation of `newBuilder` for all mutable maps in terms of `empty`.

     A common implementation of `newBuilder` for all mutable maps in terms of `empty`.

     Overrides `MapLike` implementation for better efficiency.

     Attributes
       protected[this]
     Definition Classes
       MapLike → MapLike → TraversableLike → HasNewBuilder

111. #### def nonEmpty: Boolean

     Tests whether the multimap is not empty.

     Tests whether the multimap is not empty.

     returns

       `true` if the multimap contains at least one element, `false` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

112. #### final def notify(): Unit

     Wakes up a single thread that is waiting on the receiver object's monitor.

     Wakes up a single thread that is waiting on the receiver object's monitor.

     Definition Classes
       AnyRef
     Note

       not specified by SLS as a member of AnyRef

113. #### final def notifyAll(): Unit

     Wakes up all threads that are waiting on the receiver object's monitor.

     Wakes up all threads that are waiting on the receiver object's monitor.

     Definition Classes
       AnyRef
     Note

       not specified by SLS as a member of AnyRef

114. #### def orElse[A1 <: A, B1 >: Set[B]](that: PartialFunction[A1, B1]): PartialFunction[A1, B1]

     Composes this partial function with a fallback partial function which gets applied where this partial function is not defined.

     Composes this partial function with a fallback partial function which gets applied where this partial function is not defined.

     A1

       the argument type of the fallback function

     B1

       the result type of the fallback function

     that

       the fallback function

     returns

       a partial function which has as domain the union of the domains of this partial function and `that`. The resulting partial function takes `x` to `this(x)` where `this` is defined, and to `that(x)` where it is not.

     Definition Classes
       PartialFunction

115. #### def par: ParMap[A, Set[B]]

     Returns a parallel implementation of this collection.

     Returns a parallel implementation of this collection.

     For most collection types, this method creates a new parallel collection by copying all the elements. For these collection, `par` takes linear time. Mutable collections in this category do not produce a mutable parallel collection that has the same underlying dataset, so changes in one collection will not be reflected in the other one.

     Specific collections (e.g. `ParArray` or `mutable.ParHashMap`) override this default behaviour by creating a parallel collection which shares the same underlying dataset. For these collections, `par` takes constant or sublinear time.

     All parallel collections return a reference to themselves.

     returns

       a parallel implementation of this collection

     Definition Classes
       Parallelizable

116. #### def parCombiner: Combiner[(A, Set[B]), ParMap[A, Set[B]]]

     The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

     The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

     returns

       a combiner for the parallel collection of type `ParRepr`

     Attributes
       protected[this]
     Definition Classes
       MapLike → MapLike → TraversableLike → Parallelizable

117. #### def partition(p: ((A, Set[B])) ⇒ Boolean): (Map[A, Set[B]], Map[A, Set[B]])

     Partitions this multimap in two multimaps according to a predicate.

     Partitions this multimap in two multimaps according to a predicate.

     p

       the predicate on which to partition.

     returns

       a pair of multimaps: the first multimap consists of all elements that satisfy the predicate `p` and the second multimap consists of all elements that don't. The relative order of the elements in the resulting multimaps is the same as in the original multimap.

     Definition Classes
       TraversableLike → GenTraversableLike

118. #### abstract def product: (A, Set[B])

     [use case] Multiplies up the elements of this collection.

     [use case]

     Multiplies up the elements of this collection.

     returns

       the product of all elements of this multimap with respect to the `*` operator in `num`.

     Definition Classes
       GenTraversableOnce

119. #### def product[B >: (A, Set[B])](implicit num: Numeric[B]): B

     Multiplies up the elements of this collection.

     Multiplies up the elements of this collection.

     B

       the result type of the `*` operator.

     num

       an implicit parameter defining a set of numeric operations which includes the `*` operator to be used in forming the product.

     returns

       the product of all elements of this multimap with respect to the `*` operator in `num`.

     Definition Classes
       TraversableOnce → GenTraversableOnce

120. #### def put(key: A, value: Set[B]): Option[Set[B]]

     Adds a new key/value pair to this map and optionally returns previously bound value.

     Adds a new key/value pair to this map and optionally returns previously bound value. If the map already contains a mapping for the key, it will be overridden by the new value.

     key

       the key to update

     value

       the new value

     returns

       an option value containing the value associated with the key before the `put` operation was executed, or `None` if `key` was not defined in the map before.

     Definition Classes
       MapLike

121. #### def reduce[A1 >: (A, Set[B])](op: (A1, A1) ⇒ A1): A1

     Reduces the elements of this multimap using the specified associative binary operator.

     Reduces the elements of this multimap using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     A1

       A type parameter for the binary operator, a supertype of `A`.

     op

       A binary operator that must be associative.

     returns

       The result of applying reduce operator `op` between all the elements if the multimap is nonempty.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Exceptions thrown
       UnsupportedOperationException

       if this multimap is empty.

122. #### def reduceLeft[B >: (A, Set[B])](op: (B, (A, Set[B])) ⇒ B): B

     Definition Classes
       TraversableOnce

123. #### def reduceLeftOption[B >: (A, Set[B])](op: (B, (A, Set[B])) ⇒ B): Option[B]

     Optionally applies a binary operator to all elements of this multimap, going left to right.

     Optionally applies a binary operator to all elements of this multimap, going left to right.

     Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceLeft(op)` is this multimap is nonempty, `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

124. #### def reduceOption[A1 >: (A, Set[B])](op: (A1, A1) ⇒ A1): Option[A1]

     Reduces the elements of this multimap, if any, using the specified associative binary operator.

     Reduces the elements of this multimap, if any, using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     A1

       A type parameter for the binary operator, a supertype of `A`.

     op

       A binary operator that must be associative.

     returns

       An option value containing result of applying reduce operator `op` between all the elements if the collection is nonempty, and `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

125. #### def reduceRight[B >: (A, Set[B])](op: ((A, Set[B]), B) ⇒ B): B

     Applies a binary operator to all elements of this multimap, going right to left.

     Applies a binary operator to all elements of this multimap, going right to left.

     Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       the result of inserting `op` between consecutive elements of this multimap, going right to left:

                       op(x,,1,,, op(x,,2,,, ..., op(x,,n-1,,, x,,n,,)...))

       where `x1, ..., xn` are the elements of this multimap.

     Definition Classes
       IterableLike → TraversableOnce → GenTraversableOnce
     Exceptions thrown
       `UnsupportedOperationException`

       if this multimap is empty.

126. #### def reduceRightOption[B >: (A, Set[B])](op: ((A, Set[B]), B) ⇒ B): Option[B]

     Optionally applies a binary operator to all elements of this multimap, going right to left.

     Optionally applies a binary operator to all elements of this multimap, going right to left.

     Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceRight(op)` is this multimap is nonempty, `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

127. #### def remove(key: A): Option[Set[B]]

     Removes a key from this map, returning the value associated previously with that key as an option.

     Removes a key from this map, returning the value associated previously with that key as an option.

     key

       the key to be removed

     returns

       an option value containing the value associated previously with `key`, or `None` if `key` was not defined in the map before.

     Definition Classes
       MapLike

128. #### def removeBinding(key: A, value: B): MultiMap.this.type

     Removes the binding of `value` to `key` if it exists.

     Removes the binding of `value` to `key` if it exists.

     If this was the last value assigned to the specified key, the set assigned to that key will be removed as well.

     key

       The key of the binding.

     value

       The value to remove.

     returns

       A reference to this multimap.

129. #### def repr: Map[A, Set[B]]

     The collection of type multimap underlying this `TraversableLike` object.

     The collection of type multimap underlying this `TraversableLike` object. By default this is implemented as the `TraversableLike` object itself, but this can be overridden.

     Definition Classes
       TraversableLike → GenTraversableLike

130. #### def result(): Map[A, Set[B]]

     The result when this map is used as a builder

     The result when this map is used as a builder

     returns

       the map representation itself.

     Definition Classes
       MapLike → Builder

131. #### def retain(p: (A, Set[B]) ⇒ Boolean): MultiMap.this.type

     Retains only those mappings for which the predicate `p` returns `true`.

     Retains only those mappings for which the predicate `p` returns `true`.

     p

       The test predicate

     Definition Classes
       MapLike

132. #### def reversed: List[(A, Set[B])]

     Attributes
       protected[this]
     Definition Classes
       TraversableOnce

133. #### abstract def sameElements(that: GenIterable[(A, Set[B])]): Boolean

     [use case] Checks if the other iterable collection contains the same elements in the same order as this multimap.

     [use case]

     Checks if the other iterable collection contains the same elements in the same order as this multimap.

     that

       the collection to compare with.

     returns

       `true`, if both collections contain the same elements in the same order, `false` otherwise.

     Definition Classes
       GenIterableLike

134. #### def sameElements[B >: (A, Set[B])](that: GenIterable[B]): Boolean

     Checks if the other iterable collection contains the same elements in the same order as this multimap.

     Checks if the other iterable collection contains the same elements in the same order as this multimap.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     B

       the type of the elements of collection `that`.

     that

       the collection to compare with.

     returns

       `true`, if both collections contain the same elements in the same order, `false` otherwise.

     Definition Classes
       IterableLike → GenIterableLike

135. #### def scan[B >: (A, Set[B]), That](z: B)(op: (B, B) ⇒ B)(implicit cbf: CanBuildFrom[Map[A, Set[B]], B, That]): That

     Computes a prefix scan of the elements of the collection.

     Computes a prefix scan of the elements of the collection.

     Note: The neutral element `z` may be applied more than once.

     B

       element type of the resulting collection

     That

       type of the resulting collection

     z

       neutral element for the operator `op`

     op

       the associative operator for the scan

     cbf

       combiner factory which provides a combiner

     returns

       a new multimap containing the prefix scan of the elements in this multimap

     Definition Classes
       TraversableLike → GenTraversableLike

136. #### def scanLeft[B, That](z: B)(op: (B, (A, Set[B])) ⇒ B)(implicit bf: CanBuildFrom[Map[A, Set[B]], B, That]): That

     Produces a collection containing cummulative results of applying the operator going left to right.

     Produces a collection containing cummulative results of applying the operator going left to right.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     B

       the type of the elements in the resulting collection

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       TraversableLike → GenTraversableLike

137. #### def scanRight[B, That](z: B)(op: ((A, Set[B]), B) ⇒ B)(implicit bf: CanBuildFrom[Map[A, Set[B]], B, That]): That

     Produces a collection containing cummulative results of applying the operator going right to left.

     Produces a collection containing cummulative results of applying the operator going right to left. The head of the collection is the last cummulative result.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     Example:

            List(1, 2, 3, 4).scanRight(0)(_ + _) == List(10, 9, 7, 4, 0)

     B

       the type of the elements in the resulting collection

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       TraversableLike → GenTraversableLike
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) The behavior of `scanRight` has changed. The previous behavior can be reproduced with scanRight.reverse.

138. #### def seq: Map[A, Set[B]]

     A version of this collection with all of the operations implemented sequentially (i.

     A version of this collection with all of the operations implemented sequentially (i.e. in a single-threaded manner).

     This method returns a reference to this collection. In parallel collections, it is redefined to return a sequential implementation of this collection. In both cases, it has O(1) complexity.

     returns

       a sequential view of the collection.

     Definition Classes
       Map → Map → GenMap → GenMapLike → Iterable → Iterable → GenIterable → Traversable → Traversable → GenTraversable → Parallelizable → TraversableOnce → GenTraversableOnce

139. #### def size: Int

     The size of this multimap.

     The size of this multimap.

     returns

       the number of elements in this multimap.

     Definition Classes
       TraversableOnce → GenTraversableOnce

140. #### def sizeHint(coll: scala.collection.TraversableLike[_, _], delta: Int = 0): Unit

     Gives a hint that one expects the `result` of this builder to have the same size as the given collection, plus some delta.

     Gives a hint that one expects the `result` of this builder to have the same size as the given collection, plus some delta. This will provide a hint only if the collection is known to have a cheap `size` method. Currently this is assumed to be the case if and only if the collection is of type `IndexedSeqLike`. Some builder classes will optimize their representation based on the hint. However, builder implementations are still required to work correctly even if the hint is wrong, i.e. a different number of elements is added.

     coll

       the collection which serves as a hint for the result's size.

     delta

       a correction to add to the `coll.size` to produce the size hint.

     Definition Classes
       Builder

141. #### def sizeHint(size: Int): Unit

     Gives a hint how many elements are expected to be added when the next `result` is called.

     Gives a hint how many elements are expected to be added when the next `result` is called. Some builder classes will optimize their representation based on the hint. However, builder implementations are still required to work correctly even if the hint is wrong, i.e. a different number of elements is added.

     size

       the hint how many elements will be added.

     Definition Classes
       Builder

142. #### def sizeHintBounded(size: Int, boundingColl: scala.collection.TraversableLike[_, _]): Unit

     Gives a hint how many elements are expected to be added when the next `result` is called, together with an upper bound given by the size of some other collection.

     Gives a hint how many elements are expected to be added when the next `result` is called, together with an upper bound given by the size of some other collection. Some builder classes will optimize their representation based on the hint. However, builder implementations are still required to work correctly even if the hint is wrong, i.e. a different number of elements is added.

     size

       the hint how many elements will be added.

     boundingColl

       the bounding collection. If it is an IndexedSeqLike, then sizes larger than collection's size are reduced.

     Definition Classes
       Builder

143. #### def slice(from: Int, until: Int): Map[A, Set[B]]

     Selects an interval of elements.

     Selects an interval of elements. The returned collection is made up of all elements `x` which satisfy the invariant:

            from <= indexOf(x) < until

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     from

       the lowest index to include from this multimap.

     until

       the highest index to EXCLUDE from this multimap.

     returns

       a multimap containing the elements greater than or equal to index `from` extending up to (but not including) index `until` of this multimap.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableLike

144. #### def sliding[B >: (A, Set[B])](size: Int, step: Int): Iterator[Map[A, Set[B]]]

     Definition Classes
       IterableLike

145. #### def sliding[B >: (A, Set[B])](size: Int): Iterator[Map[A, Set[B]]]

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.)

     size

       the number of elements per group

     returns

       An iterator producing multimaps of size `size`, except the last and the only element will be truncated if there are fewer elements than size.

     Definition Classes
       IterableLike
     See also

       Iterator#sliding

146. #### def span(p: ((A, Set[B])) ⇒ Boolean): (Map[A, Set[B]], Map[A, Set[B]])

     Splits this multimap into a prefix/suffix pair according to a predicate.

     Splits this multimap into a prefix/suffix pair according to a predicate.

     Note: `c span p` is equivalent to (but possibly more efficient than) `(c takeWhile p, c dropWhile p)`, provided the evaluation of the predicate `p` does not cause any side-effects.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     p

       the test predicate

     returns

       a pair consisting of the longest prefix of this multimap whose elements all satisfy `p`, and the rest of this multimap.

     Definition Classes
       TraversableLike → GenTraversableLike

147. #### def splitAt(n: Int): (Map[A, Set[B]], Map[A, Set[B]])

     Splits this multimap into two at a given position.

     Splits this multimap into two at a given position. Note: `c splitAt n` is equivalent to (but possibly more efficient than) `(c take n, c drop n)`.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     n

       the position at which to split.

     returns

       a pair of multimaps consisting of the first `n` elements of this multimap, and the other elements.

     Definition Classes
       TraversableLike → GenTraversableLike

148. #### def stringPrefix: String

     Defines the prefix of this object's `toString` representation.

     Defines the prefix of this object's `toString` representation.

     returns

       a string representation which starts the result of `toString` applied to this multimap. Unless overridden in subclasses, the string prefix of every map is `"Map"`.

     Definition Classes
       MapLike → TraversableLike → GenTraversableLike

149. #### abstract def sum: (A, Set[B])

     [use case] Sums up the elements of this collection.

     [use case]

     Sums up the elements of this collection.

     returns

       the sum of all elements of this multimap with respect to the `+` operator in `num`.

     Definition Classes
       GenTraversableOnce

150. #### def sum[B >: (A, Set[B])](implicit num: Numeric[B]): B

     Sums up the elements of this collection.

     Sums up the elements of this collection.

     B

       the result type of the `+` operator.

     num

       an implicit parameter defining a set of numeric operations which includes the `+` operator to be used in forming the sum.

     returns

       the sum of all elements of this multimap with respect to the `+` operator in `num`.

     Definition Classes
       TraversableOnce → GenTraversableOnce

151. #### final def synchronized[T0](arg0: ⇒ T0): T0

     Definition Classes
       AnyRef

152. #### def tail: Map[A, Set[B]]

     Selects all elements except the first.

     Selects all elements except the first.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     returns

       a multimap consisting of all elements of this multimap except the first one.

     Definition Classes
       TraversableLike → GenTraversableLike
     Exceptions thrown
       `UnsupportedOperationException`

       if the multimap is empty.

153. #### def tails: Iterator[Map[A, Set[B]]]

     Iterates over the tails of this multimap.

     Iterates over the tails of this multimap. The first value will be this multimap and the final one will be an empty multimap, with the intervening values the results of successive applications of `tail`.

     returns

       an iterator over all the tails of this multimap

     Definition Classes
       TraversableLike
     Example:

     1. `List(1,2,3).tails = Iterator(List(1,2,3), List(2,3), List(3), Nil)`

154. #### def take(n: Int): Map[A, Set[B]]

     Selects first n elements.

     Selects first n elements.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     n

       Tt number of elements to take from this multimap.

     returns

       a multimap consisting only of the first `n` elements of this multimap, or else the whole multimap, if it has less than `n` elements.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableLike

155. #### def takeRight(n: Int): Map[A, Set[B]]

     Selects last n elements.

     Selects last n elements.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     n

       the number of elements to take

     returns

       a multimap consisting only of the last `n` elements of this multimap, or else the whole multimap, if it has less than `n` elements.

     Definition Classes
       IterableLike

156. #### def takeWhile(p: ((A, Set[B])) ⇒ Boolean): Map[A, Set[B]]

     Takes longest prefix of elements that satisfy a predicate.

     Takes longest prefix of elements that satisfy a predicate.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     p

       The predicate used to test elements.

     returns

       the longest prefix of this multimap whose elements all satisfy the predicate `p`.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableLike

157. #### def thisCollection: Iterable[(A, Set[B])]

     The underlying collection seen as an instance of `MultiMap`.

     The underlying collection seen as an instance of `MultiMap`. By default this is implemented as the current collection object itself, but this can be overridden.

     Attributes
       protected[this]
     Definition Classes
       IterableLike → TraversableLike

158. #### abstract def toArray: Array[(A, Set[B])]

     [use case] Converts this multimap to an array.

     [use case]

     Converts this multimap to an array.

     returns

       an array containing all elements of this multimap.

     Definition Classes
       GenTraversableOnce

159. #### def toArray[B >: (A, Set[B])](implicit arg0: ClassManifest[B]): Array[B]

     Converts this multimap to an array.

     Converts this multimap to an array.

     B

       the type of the elements of the array. A `ClassManifest` for this type must be available.

     returns

       an array containing all elements of this multimap.

     Definition Classes
       TraversableOnce → GenTraversableOnce

160. #### def toBuffer[C >: (A, Set[B])]: Buffer[C]

     Converts this multimap to a mutable buffer.

     Converts this multimap to a mutable buffer.

     returns

       a buffer containing all elements of this multimap.

     Definition Classes
       MapLike → TraversableOnce → GenTraversableOnce

161. #### def toCollection(repr: Map[A, Set[B]]): Iterable[(A, Set[B])]

     A conversion from collections of type `Repr` to `MultiMap` objects.

     A conversion from collections of type `Repr` to `MultiMap` objects. By default this is implemented as just a cast, but this can be overridden.

     Attributes
       protected[this]
     Definition Classes
       IterableLike → TraversableLike

162. #### def toIndexedSeq[B >: (A, Set[B])]: IndexedSeq[B]

     Converts this multimap to an indexed sequence.

     Converts this multimap to an indexed sequence.

     returns

       an indexed sequence containing all elements of this multimap.

     Definition Classes
       TraversableOnce → GenTraversableOnce

163. #### def toIterable: Iterable[(A, Set[B])]

     Converts this multimap to an iterable collection.

     Converts this multimap to an iterable collection. Note that the choice of target `Iterable` is lazy in this default implementation as this `TraversableOnce` may be lazy and unevaluated (i.e. it may be an iterator which is only traversable once).

     returns

       an `Iterable` containing all elements of this multimap.

     Definition Classes
       IterableLike → TraversableOnce → GenTraversableOnce

164. #### def toIterator: Iterator[(A, Set[B])]

     Returns an Iterator over the elements in this multimap.

     Returns an Iterator over the elements in this multimap. Will return the same Iterator if this instance is already an Iterator.

     returns

       an Iterator containing all elements of this multimap.

     Definition Classes
       TraversableLike → GenTraversableOnce

165. #### def toList: List[(A, Set[B])]

     Converts this multimap to a list.

     Converts this multimap to a list.

     returns

       a list containing all elements of this multimap.

     Definition Classes
       TraversableOnce → GenTraversableOnce

166. #### abstract def toMap[T, U]: Map[T, U]

     [use case] Converts this multimap to a map.

     [use case]

     Converts this multimap to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     returns

       a map containing all elements of this multimap.

     Definition Classes
       GenTraversableOnce

167. #### def toMap[T, U](implicit ev: <:<[(A, Set[B]), (T, U)]): Map[T, U]

     Converts this multimap to a map.

     Converts this multimap to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     returns

       a map containing all elements of this multimap.

     Definition Classes
       TraversableOnce → GenTraversableOnce

168. #### def toSeq: Seq[(A, Set[B])]

     Overridden for efficiency.

     Overridden for efficiency.

     returns

       a sequence containing all elements of this multimap.

     Definition Classes
       MapLike → TraversableOnce → GenTraversableOnce

169. #### def toSet[B >: (A, Set[B])]: Set[B]

     Converts this multimap to a set.

     Converts this multimap to a set.

     returns

       a set containing all elements of this multimap.

     Definition Classes
       TraversableOnce → GenTraversableOnce

170. #### def toStream: Stream[(A, Set[B])]

     Converts this multimap to a stream.

     Converts this multimap to a stream.

     returns

       a stream containing all elements of this multimap.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableOnce

171. #### def toString(): String

     Converts this multimap to a string.

     Converts this multimap to a string.

     returns

       a string representation of this collection. By default this string consists of the `stringPrefix` of this multimap, followed by all elements separated by commas and enclosed in parentheses.

     Definition Classes
       MapLike → TraversableLike → Function1 → AnyRef → Any

172. #### def toTraversable: Traversable[(A, Set[B])]

     Converts this multimap to an unspecified Traversable.

     Converts this multimap to an unspecified Traversable. Will return the same collection if this instance is already Traversable.

     returns

       a Traversable containing all elements of this multimap.

     Definition Classes
       TraversableLike → TraversableOnce → GenTraversableOnce

173. #### def transform(f: (A, Set[B]) ⇒ Set[B]): MultiMap.this.type

     Applies a transformation function to all values contained in this map.

     Applies a transformation function to all values contained in this map. The transformation function produces new values from existing keys associated values.

     f

       the transformation to apply

     returns

       the map itself.

     Definition Classes
       MapLike

174. #### def transpose[B](implicit asTraversable: ((A, Set[B])) ⇒ GenTraversableOnce[B]): Iterable[Iterable[B]]

     Transposes this multimap of traversable collections into a multimap of multimaps.

     Transposes this multimap of traversable collections into a multimap of multimaps.

     B

       the type of the elements of each traversable collection.

     asTraversable

       an implicit conversion which asserts that the element type of this multimap is a `Traversable`.

     returns

       a two-dimensional multimap of multimaps which has as nth row the nth column of this multimap.

     Definition Classes
       GenericTraversableTemplate
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) `transpose` throws an `IllegalArgumentException` if collections are not uniformly sized.

     Exceptions thrown
       `IllegalArgumentException`

       if all collections in this multimap are not of the same size.

175. #### def unzip[A1, A2](implicit asPair: ((A, Set[B])) ⇒ (A1, A2)): (Iterable[A1], Iterable[A2])

     Converts this multimap of pairs into two collections of the first and second half of each pair.

     Converts this multimap of pairs into two collections of the first and second half of each pair.

     asPair

       an implicit conversion which asserts that the element type of this multimap is a pair.

     returns

       a pair multimaps, containing the first, respectively second half of each element pair of this multimap.

     Definition Classes
       GenericTraversableTemplate

176. #### def unzip3[A1, A2, A3](implicit asTriple: ((A, Set[B])) ⇒ (A1, A2, A3)): (Iterable[A1], Iterable[A2], Iterable[A3])

     Converts this multimap of triples into three collections of the first, second, and third element of each triple.

     Converts this multimap of triples into three collections of the first, second, and third element of each triple.

     asTriple

       an implicit conversion which asserts that the element type of this multimap is a triple.

     returns

       a triple multimaps, containing the first, second, respectively third member of each element triple of this multimap.

     Definition Classes
       GenericTraversableTemplate

177. #### def update(key: A, value: Set[B]): Unit

     Adds a new key/value pair to this map.

     Adds a new key/value pair to this map. If the map already contains a mapping for the key, it will be overridden by the new value.

     key

       The key to update

     value

       The new value

     Definition Classes
       MapLike

178. #### def updated[B1 >: Set[B]](key: A, value: B1): Map[A, B1]

     Creates a new map consisting of all key/value pairs of the current map plus a new pair of a given key and value.

     Creates a new map consisting of all key/value pairs of the current map plus a new pair of a given key and value.

     B1

       the type of the added value

     key

       The key to add

     value

       The new value

     returns

       A fresh immutable map with the binding from `key` to `value` added to this map.

     Definition Classes
       MapLike → MapLike

179. #### def values: Iterable[Set[B]]

     Collects all values of this map in an iterable collection.

     Collects all values of this map in an iterable collection.

     returns

       the values of this map as an iterable.

     Definition Classes
       MapLike
     Annotations
       @migration
     Migration

       (Changed in version 2.8.0) `values` returns `Iterable[B]` rather than `Iterator[B]`.

180. #### def valuesIterator: Iterator[Set[B]]

     Creates an iterator for all values in this map.

     Creates an iterator for all values in this map.

     returns

       an iterator over all values that are associated with some key in this map.

     Definition Classes
       MapLike

181. #### def view(from: Int, until: Int): IterableView[(A, Set[B]), Map[A, Set[B]]]

     Creates a non-strict view of a slice of this multimap.

     Creates a non-strict view of a slice of this multimap.

     Note: the difference between `view` and `slice` is that `view` produces a view of the current multimap, whereas `slice` produces a new multimap.

     Note: `view(from, to)` is equivalent to `view.slice(from, to)`

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     from

       the index of the first element of the view

     until

       the index of the element following the view

     returns

       a non-strict view of a slice of this multimap, starting at index `from` and extending up to (but not including) index `until`.

     Definition Classes
       IterableLike → TraversableLike

182. #### def view: IterableView[(A, Set[B]), Map[A, Set[B]]]

     Creates a non-strict view of this multimap.

     Creates a non-strict view of this multimap.

     returns

       a non-strict view of this multimap.

     Definition Classes
       IterableLike → TraversableLike

183. #### final def wait(): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

184. #### final def wait(arg0: Long, arg1: Int): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

185. #### final def wait(arg0: Long): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

186. #### def withDefault(d: (A) ⇒ Set[B]): Map[A, Set[B]]

     The same map with a given default function.

     The same map with a given default function.

     Invoking transformer methods (e.g. `map`) will not preserve the default value.

     d

       the function mapping keys to values, used for non-present keys

     returns

       a wrapper of the map with a default value

     Definition Classes
       Map

187. #### def withDefaultValue(d: Set[B]): Map[A, Set[B]]

     The same map with a given default value.

     The same map with a given default value.

     Invoking transformer methods (e.g. `map`) will not preserve the default value.

     d

       the function mapping keys to values, used for non-present keys

     returns

       a wrapper of the map with a default value

     Definition Classes
       Map

188. #### def withFilter(p: ((A, Set[B])) ⇒ Boolean): FilterMonadic[(A, Set[B]), Map[A, Set[B]]]

     Creates a non-strict filter of this multimap.

     Creates a non-strict filter of this multimap.

     Note: the difference between `c filter p` and `c withFilter p` is that the former creates a new collection, whereas the latter only restricts the domain of subsequent `map`, `flatMap`, `foreach`, and `withFilter` operations.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     p

       the predicate used to test elements.

     returns

       an object of class `WithFilter`, which supports `map`, `flatMap`, `foreach`, and `withFilter` operations. All these operations apply to those elements of this multimap which satisfy the predicate `p`.

     Definition Classes
       TraversableLike → FilterMonadic

189. #### abstract def zip[B](that: GenIterable[B]): MultiMap[((A, Set[B]), B)]

     [use case] Returns a multimap formed from this multimap and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a multimap formed from this multimap and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     B

       the type of the second half of the returned pairs

     that

       The iterable providing the second half of each result pair

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this multimap and `that`. The length of the returned collection is the minimum of the lengths of this multimap and `that`.

     Definition Classes
       GenIterableLike

190. #### def zip[A1 >: (A, Set[B]), B, That](that: GenIterable[B])(implicit bf: CanBuildFrom[Map[A, Set[B]], (A1, B), That]): That

     Returns a multimap formed from this multimap and another iterable collection by combining corresponding elements in pairs.

     Returns a multimap formed from this multimap and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     A1

       the type of the first half of the returned pairs (this is always a supertype of the collection's element type `A`).

     B

       the type of the second half of the returned pairs

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `(A1, B)` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, (A1, B), That]`. is found.

     that

       The iterable providing the second half of each result pair

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `(A1, B)`.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this multimap and `that`. The length of the returned collection is the minimum of the lengths of this multimap and `that`.

     Definition Classes
       IterableLike → GenIterableLike

191. #### abstract def zipAll[B](that: Iterable[B], thisElem: (A, Set[B]), thatElem: B): MultiMap[((A, Set[B]), B)]

     [use case] Returns a multimap formed from this multimap and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a multimap formed from this multimap and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     that

       the iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this multimap is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this multimap.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this multimap and `that`. The length of the returned collection is the maximum of the lengths of this multimap and `that`. If this multimap is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this multimap, `thatElem` values are used to pad the result.

     Definition Classes
       GenIterableLike

192. #### def zipAll[B, A1 >: (A, Set[B]), That](that: GenIterable[B], thisElem: A1, thatElem: B)(implicit bf: CanBuildFrom[Map[A, Set[B]], (A1, B), That]): That

     Returns a multimap formed from this multimap and another iterable collection by combining corresponding elements in pairs.

     Returns a multimap formed from this multimap and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     that

       the iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this multimap is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this multimap.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this multimap and `that`. The length of the returned collection is the maximum of the lengths of this multimap and `that`. If this multimap is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this multimap, `thatElem` values are used to pad the result.

     Definition Classes
       IterableLike → GenIterableLike

193. #### abstract def zipWithIndex: MultiMap[((A, Set[B]), Int)]

     [use case] Zips this multimap with its indices.

     [use case]

     Zips this multimap with its indices.

     returns

       A new collection of type `That` containing pairs consisting of all elements of this multimap paired with their index. Indices start at `0`.

     Definition Classes
       GenIterableLike

194. #### def zipWithIndex[A1 >: (A, Set[B]), That](implicit bf: CanBuildFrom[Map[A, Set[B]], (A1, Int), That]): That

     Zips this multimap with its indices.

     Zips this multimap with its indices.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     A1

       the type of the first half of the returned pairs (this is always a supertype of the collection's element type `A`).

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `(A1, Int)` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, (A1, Int), That]`. is found.

     returns

       A new collection of type `That` containing pairs consisting of all elements of this multimap paired with their index. Indices start at `0`.

     Definition Classes
       IterableLike → GenIterableLike

### Deprecated Value Members

1. #### def add(key: A, value: B): MultiMap.this.type

   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use addBinding instead

2. #### def elements: Iterator[(A, Set[B])]

   Definition Classes
     IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `iterator' instead`

3. #### def first: (A, Set[B])

   Definition Classes
     IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `head' instead`

4. #### def firstOption: Option[(A, Set[B])]

   `None` if iterable is empty.

   `None` if iterable is empty.

   Definition Classes
     IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `headOption' instead`

5. #### def mapElements[C](f: (Set[B]) ⇒ C): Map[A, C]

   Definition Classes
     MapLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `mapValues' instead`

6. #### def projection: IterableView[(A, Set[B]), Map[A, Set[B]]]

   returns a projection that can be used to call non-strict `filter`, `map`, and `flatMap` methods that build projections of the collection.

   returns a projection that can be used to call non-strict `filter`, `map`, and `flatMap` methods that build projections of the collection.

   Definition Classes
     IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `view' instead`

7. #### def removeKey(key: A): Option[Set[B]]

   If given key is defined in this map, remove it and return associated value as an Option.

   If given key is defined in this map, remove it and return associated value as an Option. If key is not present return None.

   key

     the key to be removed

   Definition Classes
     MapLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) Use `remove' instead`

### Inherited from Map[A, Set[B]]

### Inherited from MapLike[A, Set[B], Map[A, Set[B]]]

### Inherited from Cloneable[Map[A, Set[B]]]

### Inherited from Shrinkable[A]

### Inherited from Builder[(A, Set[B]), Map[A, Set[B]]]

### Inherited from Growable[(A, Set[B])]

### Inherited from Map[A, Set[B]]

### Inherited from MapLike[A, Set[B], Map[A, Set[B]]]

### Inherited from Subtractable[A, Map[A, Set[B]]]

### Inherited from PartialFunction[A, Set[B]]

### Inherited from (A) ⇒ Set[B]

### Inherited from GenMap[A, Set[B]]

### Inherited from GenMapLike[A, Set[B], Map[A, Set[B]]]

### Inherited from Iterable[(A, Set[B])]

### Inherited from IterableLike[(A, Set[B]), Map[A, Set[B]]]

### Inherited from Equals

### Inherited from GenIterable[(A, Set[B])]

### Inherited from GenIterableLike[(A, Set[B]), Map[A, Set[B]]]

### Inherited from Traversable[(A, Set[B])]

### Inherited from Mutable

### Inherited from Traversable[(A, Set[B])]

### Inherited from GenTraversable[(A, Set[B])]

### Inherited from GenericTraversableTemplate[(A, Set[B]), Iterable]

### Inherited from TraversableLike[(A, Set[B]), Map[A, Set[B]]]

### Inherited from GenTraversableLike[(A, Set[B]), Map[A, Set[B]]]

### Inherited from Parallelizable[(A, Set[B]), ParMap[A, Set[B]]]

### Inherited from TraversableOnce[(A, Set[B])]

### Inherited from GenTraversableOnce[(A, Set[B])]

### Inherited from FilterMonadic[(A, Set[B]), Map[A, Set[B]]]

### Inherited from HasNewBuilder[(A, Set[B]), Map[A, Set[B]]]

### Inherited from AnyRef

### Inherited from Any